--[========================================================================[--

Splash screen code for Thrust II Reloaded.

Copyright © 2015-2018 Pedro Gimeno Fortea

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

--]========================================================================]--

local splash = {}

local la,le,lfs,lf,lg,li,lj,lk,lm,lmo,lp,ls,lsys,lth,lt,lw = require'ns'()

local time

function splash.load()
  --splash.image = lg.newImage("img/splash.jpg")
  splash.imageBck = lg.newImage("img/splash/splashBck.png")
  splash.imageBck2 = lg.newImage("img/splash/splashBck2.png")
  splash.imageBlkFrame = lg.newImage("img/splash/imageBlkFrame.png")
  
  splash.imageShip = lg.newImage("img/splash/splashShip.png")
  splash.imageTitle = lg.newImage("img/splash/splashTitle.png")
  splash.imageRobotArm = lg.newImage("img/splash/splashSRobotArm.png")
  
  -- Music
 
  splashMusic = la.newSource("snd/Thrust II - menu.ogg", "stream")
  splashMusic:setVolume(0.5)
  splashMusic:setLooping(true)
   
  thrustsnd = la.newSource("snd/jet_lp.ogg", "static")
  thrustsnd:setLooping(true)
end

function splash.activate()
  time = 15
  timer2 = 0
 
  splashMusic:play()
  sndstate = "playing"
  playing = true
  thrustsnd:play()
end

function splash.update(dt)
  time = time - dt
  timer2 = timer2 + dt
  if time <= 0 then
		if sndstate == "playing" then
			--splashMusic:stop()
			--sndstate = "stopped"
		end
		thrustsnd:stop()
    main.activate(screens.menu)
    touchEnabled = true
    
	
    return
  end
  
  if button2pressed==true  then
	main.activate(screens.menu)
	touchEnabled = true
end

  		
		
		-- Set shader uniforms for primary light source
        vectorNormalsShader:send("LightPos1", {0.5,0.5,0.5})
        vectorNormalsShader:send("LightColor1", {0,0,1.0,1.5+timer2/10})
        
        vectorNormalsShader:send("LightPos2", {0.5,0.8,0.2})
        vectorNormalsShader:send("LightColor2", {0,1,0.5,0.5,1.5})
        
        vectorNormalsShader:send("AmbientColor", {1,0.0,0.0+timer2/10,1.0})
        
         -- Set other shader parameters for normal mapping
        vectorNormalsShader:send("Resolution", {love.graphics.getWidth(), love.graphics.getHeight()})
        vectorNormalsShader:send("Falloff", {0.2, 0.8, 1.2-timer2/10})

end

function splash.draw()
  --main.drawaligned(5, splash.image, main.wcx, main.wcy,0,main.wwNFS/4096,main.whNFS/4096)
  
  love.graphics.setColor(0,0,0,1)
  love.graphics.rectangle("fill",0,0,main.wwNFS,main.whNFS)
  --fade in
  if time >5 then love.graphics.setColor(1,1,1,timer2/2)
  -- fade out
  else	 love.graphics.setColor(1,1,1,time)
  end
  
  
  main.drawaligned(5, splash.imageBck2, -(time + 4)*10 + main.wcx, main.wcy,0,main.wwNFS/4096,main.whNFS/4096)
  main.drawaligned(5, splash.imageBlkFrame, main.wcx, main.wcy,0,main.wwNFS/4096,main.whNFS/4096)
  main.drawaligned(5, splash.imageBck, -(time + 4)*10 + main.wcx, main.wcy,0,0.1-(time + 4)/100 + main.wwNFS/4096,0.1-(time + 4)/100 + main.whNFS/4096)
  main.drawaligned(5, splash.imageShip, main.wcx, main.wcy,0,(time + 4)/50 + main.wwNFS/4096,(time + 4)/50 + main.whNFS/4096)
  main.drawaligned(5, splash.imageTitle, main.wcx, main.wcy,0,main.wwNFS/4096,main.whNFS/4096)
  main.drawaligned(5, splash.imageRobotArm, main.wcx, main.wcy,0,(time + 4)/50+main.wwNFS/4096,(time + 4)/50+main.whNFS/4096)
  
	
end

function splash.keyreleased(k)
  main.activate(screens.menu)
  return
end

return splash
