-- touchControls.lua

require ("touchControls/Menu/Buttons")
require ("touchControls/Menu/DrawButton")

touchControls = {
  leftThumbstickRadius = 240,
  rightThumbstickRadius = 240,
  buttonRadius = 150,
  buttonDistance = 160,
  leftxaxis = 0,
  leftyaxis = 0,
  rightxaxis = 0,
  rightyaxis = 0,
  leftThumbstickPressed = false,
  rightThumbstickPressed = false,
  buttons = {}
}

touchControls.layout="arcade"


touchControls.layout="gamepad"

-- Enum for layout types
local LayoutType = {
	GAMEPAD = 1,
    ARCADE = 2,
    KEYBOARD = 3, -- Add KEYBOARD layout
}

require ("touchControls/Gamepad/createGamepadButtons")
require ("touchControls/Gamepad/createArcadeButtons")
require ("touchControls/Gamepad/removeLeftThumbstickButtons")
require ("touchControls/Gamepad/removeRightThumbstickButtons")
require ("touchControls/Gamepad/toggleLayout")
require ("touchControls/Gamepad/touchEvents")
require ("touchControls/Gamepad/mouseEvents")
require ("touchControls/Menu/checkMenuButtons")
require ("touchControls/Menu/IsHovered")

function shootnow(dt)
	if Player.overloaded == false then
		Player.shooting = true
		shooting=true	-- this will be used globally (on main.lua) to set controller vibration
		Player.streamLength = math.min(Player.streamLength + STREAM_SPEED*dt, MAX_STREAM)
		stats[2] = stats[2] + 20*dt
	else
		Player.shooting = false
		Player.streamLength = 0
		shooting=false	-- this will be used globally (on main.lua) to set controller vibration
		return
	end
end
touchControls.layout = "arcade"
function touchControls:init()
 --if not (touchControls.layout == "keyboard") then
  -- Create left thumbstick
  self.leftThumbstickX = love.graphics.getWidth() / 3.2
  self.leftThumbstickY = love.graphics.getHeight() / 1.2

  -- Create right thumbstick
  --self.rightThumbstickX = love.graphics.getWidth() * 3 / 4
  --self.rightThumbstickY = love.graphics.getHeight() / 1.8
--end
 -- Create buttons based on layout
  if touchControls.layout == "gamepad" then
    --self:createGamepadButtons()
  elseif touchControls.layout == "arcade" then
    self:createArcadeButtons()
  elseif touchControls.layout == "keyboard" then
  end
	
end

function initParametersTouch()
if MobileOrientation=="landscape" then
touchControls.leftThumbstickRadius = 400
touchControls.rightThumbstickRadius = 400
touchControls.buttonRadius = 200
touchControls.buttonDistance = 60
touchControls.leftxaxis = 0
touchControls.leftyaxis = 0
touchControls.rightxaxis = 0
touchControls.rightyaxis = 0
touchControls.leftThumbstickPressed = false
touchControls.rightThumbstickPressed = false
touchControls.leftThumbstickY = love.graphics.getHeight() / 2
buttons = {}

elseif MobileOrientation=="portrait" then
touchControls.leftThumbstickRadius = 140
touchControls.rightThumbstickRadius = 240
touchControls.buttonRadius = 100
touchControls.buttonDistance = 160
touchControls.leftxaxis = 0
touchControls.leftyaxis = 0
touchControls.rightxaxis = 0
touchControls.rightyaxis = 0
touchControls.leftThumbstickPressed = false
touchControls.rightThumbstickPressed = false
touchControls.leftThumbstickY = love.graphics.getHeight() / 1.2
  buttons = {}

end
end


require ("touchControls/Gamepad/updateThumbstickAxes")
require ("touchControls/Gamepad/checkButtonPress")
require ("touchControls/Gamepad/drawTouchControls")
require ("touchControls/Gamepad/adjustButtons")



-- Return touchControls table
return touchControls

